"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrmLibrary = void 0;
class OrmLibrary {
    // eslint-disable-next-line no-useless-constructor
    constructor(orm) {
        this.orm = orm;
    }
    load() {
        this.orm.exp.addFunction('orm.execute(expression:string,data:any,options:any):any', (expression, data, options) => __awaiter(this, void 0, void 0, function* () {
            if (expression !== undefined && expression !== null && expression.trim() !== '') {
                return yield this.orm.execute(expression, data, options);
            }
            return null;
        }), { async: true, description: 'Execute an ORM expression' });
        this.orm.exp.addFunction('orm.plan(expression:string,options:any):any', (expression, options) => {
            if (expression !== undefined && expression !== null && expression.trim() !== '') {
                return this.orm.plan(expression, options);
            }
            return null;
        }, { description: 'Plan an ORM expression' });
        this.orm.exp.addFunction('orm.metadata(expression:string):any', (expression) => {
            if (expression !== undefined && expression !== null && expression.trim() !== '') {
                return this.orm.metadata(expression);
            }
            return null;
        }, { description: 'Get metadata from an ORM expression' });
        this.orm.exp.addFunction('orm.model(expression:string):any', (expression) => {
            if (expression !== undefined && expression !== null && expression.trim() !== '') {
                return this.orm.model(expression);
            }
            return null;
        }, { description: 'Get model from an ORM expression' });
        this.orm.exp.addFunction('orm.parameters(expression:string):any', (expression) => {
            if (expression !== undefined && expression !== null && expression.trim() !== '') {
                return this.orm.parameters(expression);
            }
            return null;
        }, { description: 'Get parameters from an ORM expression' });
        this.orm.exp.addFunction('orm.constraints(expression:string):any', (expression) => {
            if (expression !== undefined && expression !== null && expression.trim() !== '') {
                return this.orm.constraints(expression);
            }
            return null;
        }, { description: 'Get constraints from an ORM expression' });
    }
}
exports.OrmLibrary = OrmLibrary;
//# sourceMappingURL=ormLibrary.js.map