"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable no-template-curly-in-string */
const __1 = require("../../..");
beforeAll(() => __awaiter(void 0, void 0, void 0, function* () {
    require('dotenv').config({ path: './config/countries.env' });
    yield __1.orm.init('./config/countries.yaml');
}));
describe('bitwise', () => {
    const context = JSON.parse('{}');
    test('normalize', () => {
        expect(__1.orm.normalize('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude & 1 })')).toStrictEqual('Countries.map(p=>{result:(p.longitude&1)}).filter(p=>(p.iso3==BRA)).sort(p=>asc(p.result)).page(1,1)');
        expect(__1.orm.normalize('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude | 1 })')).toStrictEqual('Countries.map(p=>{result:(p.longitude|1)}).filter(p=>(p.iso3==BRA)).sort(p=>asc(p.result)).page(1,1)');
        expect(__1.orm.normalize('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: ~ p.longitude })')).toStrictEqual('Countries.map(p=>{result:~p.longitude}).filter(p=>(p.iso3==BRA)).sort(p=>asc(p.result)).page(1,1)');
        expect(__1.orm.normalize('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude << 1 })')).toStrictEqual('Countries.map(p=>{result:(p.longitude<<1)}).filter(p=>(p.iso3==BRA)).sort(p=>asc(p.result)).page(1,1)');
        expect(__1.orm.normalize('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude ^ 1 })')).toStrictEqual('Countries.map(p=>{result:(p.longitude^1)}).filter(p=>(p.iso3==BRA)).sort(p=>asc(p.result)).page(1,1)');
        expect(__1.orm.normalize('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude >> 1 })')).toStrictEqual('Countries.map(p=>{result:(p.longitude>>1)}).filter(p=>(p.iso3==BRA)).sort(p=>asc(p.result)).page(1,1)');
    });
    test('model', () => {
        expect(__1.orm.model('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude & 1 })')).toStrictEqual([{ 'name': 'result', 'type': 'number' }]);
        expect(__1.orm.model('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude | 1 })')).toStrictEqual([{ 'name': 'result', 'type': 'number' }]);
        expect(__1.orm.model('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: ~ p.longitude })')).toStrictEqual([{ 'name': 'result', 'type': 'number' }]);
        expect(__1.orm.model('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude << 1 })')).toStrictEqual([{ 'name': 'result', 'type': 'number' }]);
        expect(__1.orm.model('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude ^ 1 })')).toStrictEqual([{ 'name': 'result', 'type': 'number' }]);
        expect(__1.orm.model('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude >> 1 })')).toStrictEqual([{ 'name': 'result', 'type': 'number' }]);
    });
    test('parameters', () => {
        expect(__1.orm.parameters('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude & 1 })')).toStrictEqual([]);
        expect(__1.orm.parameters('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude | 1 })')).toStrictEqual([]);
        expect(__1.orm.parameters('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: ~ p.longitude })')).toStrictEqual([]);
        expect(__1.orm.parameters('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude << 1 })')).toStrictEqual([]);
        expect(__1.orm.parameters('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude ^ 1 })')).toStrictEqual([]);
        expect(__1.orm.parameters('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude >> 1 })')).toStrictEqual([]);
    });
    test('constraints', () => {
        expect(__1.orm.constraints('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude & 1 })')).toStrictEqual({ "entity": "Countries", "constraints": [] });
        expect(__1.orm.constraints('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude | 1 })')).toStrictEqual({ "entity": "Countries", "constraints": [] });
        expect(__1.orm.constraints('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: ~ p.longitude })')).toStrictEqual({ "entity": "Countries", "constraints": [] });
        expect(__1.orm.constraints('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude << 1 })')).toStrictEqual({ "entity": "Countries", "constraints": [] });
        expect(__1.orm.constraints('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude ^ 1 })')).toStrictEqual({ "entity": "Countries", "constraints": [] });
        expect(__1.orm.constraints('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude >> 1 })')).toStrictEqual({ "entity": "Countries", "constraints": [] });
    });
    test('getInfo', () => {
        expect(__1.orm.plan('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude & 1 })', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.longitude & 1 AS result FROM Countries c  WHERE c.iso3 = 'BRA' ORDER BY result asc  LIMIT 0,1 " });
        expect(__1.orm.plan('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude | 1 })', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.longitude | 1 AS result FROM Countries c  WHERE c.iso3 = 'BRA' ORDER BY result asc  LIMIT 0,1 " });
        expect(__1.orm.plan('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: ~ p.longitude })', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT ~ c.longitude AS result FROM Countries c  WHERE c.iso3 = 'BRA' ORDER BY result asc  LIMIT 0,1 " });
        expect(__1.orm.plan('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude << 1 })', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.longitude << 1 AS result FROM Countries c  WHERE c.iso3 = 'BRA' ORDER BY result asc  LIMIT 0,1 " });
        expect(__1.orm.plan('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude ^ 1 })', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.longitude ^ 1 AS result FROM Countries c  WHERE c.iso3 = 'BRA' ORDER BY result asc  LIMIT 0,1 " });
        expect(__1.orm.plan('Countries.filter(p=> p.iso3=="BRA").first(p=> {result: p.longitude >> 1 })', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.longitude >> 1 AS result FROM Countries c  WHERE c.iso3 = 'BRA' ORDER BY result asc  LIMIT 0,1 " });
    });
});
//# sourceMappingURL=bitwise.test.js.map